// Led_appDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Led_app.h"
#include "Led_appDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HANDLE m_hIR;

// ļ
HANDLE hLed = INVALID_HANDLE_VALUE;

#define IO_CTL_LED_ON  0x05

#define IO_CTL_LED_OFF 0x0a
/////////////////////////////////////////////////////////////////////////////
// CLed_appDlg dialog

CLed_appDlg::CLed_appDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLed_appDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLed_appDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLed_appDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLed_appDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLed_appDlg, CDialog)
	//{{AFX_MSG_MAP(CLed_appDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnRegisterDevice)
	ON_BN_CLICKED(IDC_BUTTON2, OnDeregisterDevice)
	ON_BN_CLICKED(IDC_BUTTON3, On_LED_ON)
	ON_BN_CLICKED(IDC_BUTTON4, On_LED_OFF)
	ON_BN_CLICKED(IDC_BUTTON5, On_OpenLed)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLed_appDlg message handlers

BOOL CLed_appDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CLed_appDlg::OnRegisterDevice() 
{
	// TODO: Add your control notification handler code here
    m_hIR = RegisterDevice(TEXT("LED"),1,TEXT("LED.dll"),2);  //ļ
	if(m_hIR == NULL){
		::MessageBox(NULL,NULL,_T("load driver fail!"),MB_OK);
         }
	else
		::MessageBox(NULL,NULL,_T("load driver sucess"),MB_OK);

}

void CLed_appDlg::OnDeregisterDevice() 
{
	// TODO: Add your control notification handler code here
	::MessageBox(NULL,NULL,_T("unload driver"),MB_OK);
	DeregisterDevice(m_hIR);

}

void CLed_appDlg::On_LED_ON() 
{
	// TODO: Add your control notification handler code here
	::DeviceIoControl(hLed, IO_CTL_LED_ON, NULL, 1, NULL, 0, NULL, NULL);
}

void CLed_appDlg::On_LED_OFF() 
{
	// TODO: Add your control notification handler code here
	::DeviceIoControl(hLed, IO_CTL_LED_OFF, NULL, 1, NULL, 0, NULL, NULL);
}

void CLed_appDlg::On_OpenLed() 
{
	// TODO: Add your control notification handler code here

	//  GPIO 
	hLed = CreateFile(TEXT("LED1:"), GENERIC_READ | GENERIC_WRITE, 0, 
					   NULL, OPEN_EXISTING, 0, 0);
	
	if (hLed == INVALID_HANDLE_VALUE)
	{
		MessageBox(_T(" LED ʧ!"));
		return; 
	}
	else
		MessageBox(_T(" LED ɹ!"));
}

void CLed_appDlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	::CloseHandle(hLed);
}
